//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "GrafWnd.h"
#include "MainWindow.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGrafWindow *GrafWindow;
//---------------------------------------------------------------------------
__fastcall TGrafWindow::TGrafWindow(TComponent* Owner)
  : TForm(Owner)
{
  re=NULL;
  im=NULL;
  abs=NULL;

  maxx=1;
  maxy=1;
  minx=-1;
  miny=-1;
  minabs=0;
  maxabs=1;

  border=20;

  count=0;
  ColorDlg->Color = clRed;
}
//---------------------------------------------------------------------------

void TGrafWindow::FindBounds(bool constRatio)
{
  int i;

  if (!re || !im || !abs) return;

  maxx = re[0];
  minx = re[0];
  miny = im[0];
  maxy = im[0];
  maxabs = abs[0];
  minabs = abs[0];

  for (i=1;i<count;i++)
  {
    if (miny>im[i]) miny=im[i];
    if (maxy<im[i]) maxy=im[i];
    if (minx>re[i]) minx=re[i];
    if (maxx<re[i]) maxx=re[i];
    if (maxabs<abs[i]) maxabs=abs[i];
    if (minabs>abs[i]) minabs=abs[i];
  }
  if (minx>0) minx=0;
  if (miny>0) miny=0;
  if (maxx<0) maxx=0;
  if (maxy<0) maxy=0;
  if (minabs>0) minabs=0;
  if (maxabs<1) maxabs=1;

  if (constRatio)
  {
    if (maxx>maxy) maxy=maxx; else maxx=maxy;
    if (minx<miny) miny=minx; else minx=miny;
  }
}


void TGrafWindow::DrawAxesImg(double stepRe,double stepIm)
{

  while ((maxx-minx)/stepRe<8)
  {
    stepRe=stepRe/2;
  }

  while ((maxy-miny)/stepIm<8)
  {
    stepIm=stepIm/2;
  }

  int i=0;
  Img->Canvas->Brush->Color=clWhite;
  Img->Canvas->Brush->Style=bsSolid;
  TRect rect = TRect(0,0,Img->Width,Img->Height);
  double x = 0;

  Img->Canvas->FillRect(rect);

  Img->Canvas->Pen->Color=clBlack;
  Img->Canvas->Pen->Width=3;
  Img->Canvas->Brush->Style=bsClear;
  Img->Canvas->Rectangle(border-2,border-2,Img->Width-border+2,Img->Height-border+2);

  Img->Canvas->Pen->Color=clYellow;
  Img->Canvas->Pen->Width=3;

  Img->Canvas->MoveTo(ReToPos(0),border);
  Img->Canvas->LineTo(ReToPos(0),Img->Height-border);
  Img->Canvas->MoveTo(border,ImToPos(0));
  Img->Canvas->LineTo(Img->Width-border,ImToPos(0));

  Img->Canvas->Pen->Color=clSilver;
  Img->Canvas->Pen->Width=1;

  i=0;
  do
  {
    if (i%3==0)
    {
      Img->Canvas->Pen->Color=clBlack;
    }
    else
    {
      Img->Canvas->Pen->Color=clSilver;
    }
    Img->Canvas->MoveTo(ReToPos(x),border);
    Img->Canvas->LineTo(ReToPos(x),Img->Height-border);
    AnsiString s = FloatToStrF(x,ffFixed,3,3);
    if (ShowValues1->Checked)
      Img->Canvas->TextOutA(ReToPos(x)-15,Img->Height-border+3,s);
    x-=stepRe;
    i++;
  } while (x>minx);

  x=0;
  i=0;
  do
  {
    if (i%3==0)
    {
      Img->Canvas->Pen->Color=clBlack;
    }
    else
    {
      Img->Canvas->Pen->Color=clSilver;
    }
    Img->Canvas->MoveTo(ReToPos(x),border);
    Img->Canvas->LineTo(ReToPos(x),Img->Height-border);
    AnsiString s = FloatToStrF(x,ffFixed,3,3);
    if (ShowValues1->Checked)
      Img->Canvas->TextOutA(ReToPos(x)-15,Img->Height-border+3,s);
    x+=stepRe;
    i++;
  } while (x<maxx);

  double y = 0;
  i=0;
  do
  {
    if (i%3==0)
    {
      Img->Canvas->Pen->Color=clBlack;
    }
    else
    {
      Img->Canvas->Pen->Color=clSilver;
    }
    Img->Canvas->MoveTo(border,ImToPos(y));
    Img->Canvas->LineTo(Img->Width-border,ImToPos(y));
    AnsiString s = FloatToStrF(y,ffFixed,3,3);
    Img->Canvas->Brush->Style=bsSolid;
    if (ShowValues1->Checked)
      Img->Canvas->TextOutA(Img->Width-35,ImToPos(y)-6,s);
    y-=stepIm;
    i++;
  } while (y>miny);

  y = 0;
  i=0;
  do
  {
    if (i%3==0)
    {
      Img->Canvas->Pen->Color=clBlack;
    }
    else
    {
      Img->Canvas->Pen->Color=clSilver;
    }
    Img->Canvas->MoveTo(border,ImToPos(y));
    Img->Canvas->LineTo(Img->Width-border,ImToPos(y));
    AnsiString s = FloatToStrF(y,ffFixed,3,3);
    if (ShowValues1->Checked)
      Img->Canvas->TextOutA(Img->Width-35,ImToPos(y)-6,s);
    y+=stepIm;
    i++;
  } while (y<maxy);
}

void TGrafWindow::DrawAxesAbs(int step,double stepAbs)
{
  while (count/step<10)
  {
    step=step/2;
  }

  while ((maxabs-minabs)/stepAbs<9)
  {
    stepAbs=stepAbs/2;
  }

  int i=0;
  Img->Canvas->Brush->Color=clWhite;
  Img->Canvas->Brush->Style=bsSolid;
  TRect rect = TRect(0,0,Img->Width,Img->Height);
  double x = 0;

  Img->Canvas->FillRect(rect);

  Img->Canvas->Pen->Color=clBlack;
  Img->Canvas->Pen->Width=3;
  Img->Canvas->Brush->Style=bsClear;
  Img->Canvas->Rectangle(border-2,border-2,Img->Width-border+2,Img->Height-border+2);

  Img->Canvas->Pen->Color=clSilver;
  Img->Canvas->Pen->Width=1;

  i=0;
  do
  {
    if (i%2==0)
    {
      Img->Canvas->Pen->Color=clBlack;
    }
    else
    {
      Img->Canvas->Pen->Color=clSilver;
    }
    Img->Canvas->MoveTo(IndexToPos(i*step),border);
    Img->Canvas->LineTo(IndexToPos(i*step),Img->Height-border);
    AnsiString s = IntToStr(i*step);
    if (ShowValues1->Checked)
      Img->Canvas->TextOutA(IndexToPos(i*step)-8,Img->Height-border+3,s);
    i++;
  } while ((i-1)*step<=count);

  double y = 0;
  i=0;
  do
  {
    if (i%3==0)
    {
      Img->Canvas->Pen->Color=clBlack;
    }
    else
    {
      Img->Canvas->Pen->Color=clSilver;
    }
    Img->Canvas->MoveTo(border,AbsToPos(y));
    Img->Canvas->LineTo(Img->Width-border,AbsToPos(y));
    AnsiString s = FloatToStrF(y,ffFixed,3,3);
    Img->Canvas->Brush->Style=bsSolid;
    if (ShowValues1->Checked)
      Img->Canvas->TextOutA(1,AbsToPos(y)-6,s);
    y+=stepAbs;
    i++;
  } while (y<maxabs);
}

void TGrafWindow::Zobraz(double*RE, double *IM, double* ABS, int COUNT)
{
  re = RE;
  im = IM;
  abs = ABS;
  count = COUNT;

  Kresli();
}

void TGrafWindow::DrawImag()
{
   int i;

   if (!re || !im || !abs) return;

   int x = ReToPos(re[0]);
   int y = ImToPos(im[0]);
   Img->Canvas->MoveTo(x,y);

   Img->Canvas->Pen->Color=ColorDlg->Color;
   Img->Canvas->Pen->Width=2;

   for (i=1;i<count;i++)
   {
      x = ReToPos(re[i]);
      y = ImToPos(im[i]);
      Img->Canvas->LineTo(x,y);
   }
}

void TGrafWindow::DrawAbs()
{
   int i;

   if (!re || !im || !abs) return;

   int x = IndexToPos(0);
   int y = AbsToPos(abs[0]);
   Img->Canvas->MoveTo(x,y);

   Img->Canvas->Pen->Color=ColorDlg->Color;
   Img->Canvas->Pen->Width=2;

   for (i=1;i<count;i++)
   {
      x = IndexToPos(i);
      y = AbsToPos(abs[i]);
      Img->Canvas->LineTo(x,y);
   }
}

int TGrafWindow::ReToPos(double re)
{
  double scalex = double(Img->Width-2*border)/(maxx-minx);
  return int(border+(re-minx)*scalex);
}

int TGrafWindow::ImToPos(double im)
{
  double scaley = double(Img->Height-2*border)/(maxy-miny);
  return Img->Height-int(border+(im-miny)*scaley);
}

int TGrafWindow::IndexToPos(int i)
{
  double scalex = double(Img->Width-2*border)/double(count);
  return int(border+double(i)*scalex);
}

int TGrafWindow::AbsToPos(double abs)
{
  double scaley = double(Img->Height-2*border)/(maxabs-minabs);
  return Img->Height-int(border+(abs-minabs)*scaley);
}

void TGrafWindow::SetBorder(int b)
{
  border=b;
}


void __fastcall TGrafWindow::FormResize(TObject *Sender)
{
  Img->Picture->Bitmap->Width = Img->Width;
  Img->Picture->Bitmap->Height = Img->Height;
  Kresli();
}
//---------------------------------------------------------------------------

void __fastcall TGrafWindow::N111Click(TObject *Sender)
{
  N111->Checked = !N111->Checked;
  Kresli();
}
//---------------------------------------------------------------------------

void __fastcall TGrafWindow::ShowValues1Click(TObject *Sender)
{
  ShowValues1->Checked = !ShowValues1->Checked;
  Kresli();
}
//---------------------------------------------------------------------------

void __fastcall TGrafWindow::Color1Click(TObject *Sender)
{
  ColorDlg->Execute();
  Kresli();
}
//---------------------------------------------------------------------------


void TGrafWindow::Kresli()
{
  FindBounds(N111->Checked);
  if (Imag1->Checked)
  {
    DrawAxesImg(1,1);
    DrawImag();
  }
  if (Abs1->Checked)
  {
    DrawAxesAbs(100,1);
    DrawAbs();
  }
}
void __fastcall TGrafWindow::Imag1Click(TObject *Sender)
{
  Imag1->Checked = true;
  Abs1->Checked = false;
  Kresli();
}
//---------------------------------------------------------------------------

void __fastcall TGrafWindow::Abs1Click(TObject *Sender)
{
  Imag1->Checked = false;
  Abs1->Checked = true;
  Kresli();
}
//---------------------------------------------------------------------------


void __fastcall TGrafWindow::Save1Click(TObject *Sender)
{
  if (SaveImg->Execute())
  {
    Img->Picture->SaveToFile(SaveImg->FileName);
  }
}
//---------------------------------------------------------------------------

